# Cross-compilation linux->windows
# for dpuser:
# cmake -DCMAKE_TOOLCHAIN_FILE=../TC-mingw.cmake -DLIB_PATH=../lib/WIN64 ..
# for QFitsView:
# Qt6_DIR=../../../Qt/6.5.2/mingw_64/lib/cmake/Qt6 cmake -DCMAKE_TOOLCHAIN_FILE=../../dpuser/TC-mingw.cmake -DLIB_PATH=../lib/WIN64 ..
# given a windows QT is in ../../../Qt and the rcc.exe, moc.exe, and uic.exe are overwritten with linux programs

# the name of the target operating system
set(CMAKE_SYSTEM_NAME Windows)

# which compilers to use for C and C++
set(CMAKE_C_COMPILER   x86_64-w64-mingw32-gcc)
set(CMAKE_CXX_COMPILER x86_64-w64-mingw32-g++)

# where is the target environment located
set(CMAKE_FIND_ROOT_PATH  /usr/x86_64-w64-mingw32)

# adjust the default behavior of the FIND_XXX() commands:
# search programs in the host environment
set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)

# search headers and libraries in the target environment
#set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
#set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
